defmodule Restcrud.Application do
  # See https://hexdocs.pm/elixir/Application.html
  # for more information on OTP Applications
  @moduledoc false

  use Application

  @impl true
  def start(_type, _args) do
    # List all child processes to be supervised
    children = [
      {Plug.Cowboy,
       scheme: :http,
       plug: Restcrud.Router,
       options: [port: Application.fetch_env!(:restcrud, :port)]},
      Events.Repo
    ]

    # See https://hexdocs.pm/elixir/Supervisor.html
    # for other strategies and supported options
    opts = [strategy: :one_for_one, name: Restcrud.Supervisor]
    Supervisor.start_link(children, opts)
  end
end
